
//****************************************************************************
// Script for Tweener _bezier Option
// author nutsu
// version 0.2
//
//****************************************************************************

var edgeArray = fl.getDocumentDOM().selection[0].edges;

var tmp  = [];
var tmp2 = [];
var turn = [];
for ( i=0; i<edgeArray.length; i++ )
	tmp.push( edgeArray[i] );

var e0 = tmp.shift();
tmp2.push( e0 );
turn.push( false );
joinX0 = e0.getControl(0).x;
joinY0 = e0.getControl(0).y;
joinX2 = e0.getControl(2).x;
joinY2 = e0.getControl(2).y;

while( tmp2.length<edgeArray.length )
{
	flg_join = false;
	var min_value = -1;
	var min_pos   = -1;
	var min_index = -1;
	for( i=0; i<tmp.length; i++ )
	{
		var ed = tmp[i];
		var p0 = ed.getControl(0);
		var p2 = ed.getControl(2);
		if( p0.x==joinX2 && p0.y==joinY2 )
		{
			flg_join = true;
			tmp2.push( ed );
			turn.push( false );
			joinX2 = p2.x;
			joinY2 = p2.y;
			tmp.splice( i, 1 );
			i = 0;
		}
		else if( p2.x==joinX0 && p2.y==joinY0 )
		{
			flg_join = true;
			tmp2.unshift( ed );
			turn.push( false );
			joinX0 = p0.x;
			joinY0 = p0.y;
			tmp.splice( i, 1 );
			i = 0;
		}
		else if( p2.x==joinX2 && p2.y==joinY2 )
		{
			flg_join = true;
			tmp2.push( ed );
			turn.push( true );
			joinX2 = p0.x;
			joinY2 = p0.y;
			tmp.splice( i, 1 );
			i = 0;
		}
		else if( p0.x==joinX0 && p0.y==joinY0 )
		{
			flg_join = true;
			tmp2.unshift( ed );
			turn.push( true );
			joinX0 = p2.x;
			joinY0 = p2.y;
			tmp.splice( i, 1 );
			i = 0;
		}
		else
		{
			var min1 = (p0.x-joinX2)*(p0.x-joinX2) + (p0.y-joinY2)*(p0.y-joinY2);
			var min2 = (p2.x-joinX0)*(p2.x-joinX0) + (p2.y-joinY0)*(p2.y-joinY0);
			var min3 = (p2.x-joinX2)*(p2.x-joinX2) + (p2.y-joinY2)*(p2.y-joinY2);
			var min4 = (p0.x-joinX0)*(p0.x-joinX0) + (p0.y-joinY0)*(p0.y-joinY0);
			if( min1<min_value || min_value<0 )
			{
				min_value = min1;
				min_pos   = 1;
				min_index = i;
			}
			if( min2<min_value )
			{
				min_value = min2;
				min_pos   = 2;
				min_index = i;
			}
			if( min3<min_value )
			{
				min_value = min3;
				min_pos   = 3;
				min_index = i;
			}
			if( min4<min_value )
			{
				min_value = min4;
				min_pos   = 4;
				min_index = i;
			}
		}
	}
	//ŋߖTɘA
	if( flg_join==false )
	{
		fl.trace("debug>>" + "join nearest point." );
		var ed = tmp[min_index];
		var p0 = ed.getControl(0);
		var p2 = ed.getControl(2);
		if( min_pos==1 )
		{
			tmp2.push( ed );
			turn.push( false );
			joinX2 = p2.x;
			joinY2 = p2.y;
		}
		else if( min_pos==2 )
		{
			tmp2.unshift( ed );
			turn.push( false );
			joinX0 = p0.x;
			joinY0 = p0.y;
		}
		else if( min_pos==3 )
		{
			tmp2.push( ed );
			turn.push( true );
			joinX2 = p0.x;
			joinY2 = p0.y;
		}
		else
		{
			tmp2.unshift( ed );
			turn.push( true );
			joinX0 = p2.x;
			joinY0 = p2.y;
		}
		tmp.splice( min_index, 1 );
	}
}

var xmlstr = "<shape>\n";
for( i=0; i<tmp2.length; i++ )
{
		var ed = tmp2[i];
		var p0 = ed.getControl(0);
		var p1 = ed.getControl(1);
		var p2 = ed.getControl(2);
	xmlstr += "<edge id=\"" + i + "\"" + 
			" x0=\"" + p0.x + "\" y0=\"" +  p0.y +  "\"" + 
			" x1=\"" + p1.x + "\" y1=\"" +  p1.y +  "\"" + 
			" x2=\"" + p2.x + "\" y2=\"" +  p2.y + "\""   +
			" line=\"" +  ed.isLine + "\" />\n";

}
xmlstr += "</shape>";
fl.trace( xmlstr );

